<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container">
        <h1 class="text-center mt-3 mb-3">Danh Sách Đăng ký</h1>
        <table id="user-table" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>FirstName</th>
                    <th>LastName</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>CustomerType</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>

        </table>
    </div>


</body>
<script>
    $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gArrayUser = [];
        var gNameCol = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
        const gID_COL = 0;
        const gFIRST_NAME_COL = 1;
        const gLAST_NAME_COL = 2;
        const gCOUNTRY_COL = 3;
        const gSUBJECT_COL = 4;
        const gCUSTOMER_TYPE_COL = 5;
        const gREGISTER_STATUS_COL = 6;
        const gACTION_COL = 7;

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        goiApiGetData();
        $("#user-table").on("click", ".btn-detail", function () {
            onBtnDetail(this);
        })

        // onPageLoading();
        console.log(gArrayUser);

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading(paramList) {
            $("#user-table").DataTable({
                data: paramList,
                columns: [
                    { data: gNameCol[gID_COL] },
                    { data: gNameCol[gFIRST_NAME_COL] },
                    { data: gNameCol[gLAST_NAME_COL] },
                    { data: gNameCol[gCOUNTRY_COL] },
                    { data: gNameCol[gSUBJECT_COL] },
                    { data: gNameCol[gCUSTOMER_TYPE_COL] },
                    { data: gNameCol[gREGISTER_STATUS_COL] },
                    { data: gNameCol[gACTION_COL] },

                ],
                columnDefs: [
                    {
                        targets: gID_COL,
                        className: "text-center text-primary"
                    },
                    {
                        targets: gACTION_COL,
                        className: "text-center",
                        defaultContent: "<button class='btn btn-primary btn-detail'>Detail</button>"
                    }

                ]

            });

        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function goiApiGetData() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                type: "GET",
                success: function (res) {
                    gArrayUser = res;
                    // console.log(gArrayUser);
                    onPageLoading(res);
                },
                error: function (error) {
                    console.log(error.status);
                }
            })
        }

        console.log(gArrayUser);
        function onBtnDetail(paramElement) {
            var vRow = $(paramElement).closest("tr");
            var vTable = $("#user-table").DataTable();
            var vDataRow = vTable.row(vRow).data();
            console.log(vDataRow);
        }
    })

</script>

</html>